#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/kd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

int main(int argc, char *argv[]){
 int KB;
 int i, o;
 FILE *file;

/* Hilfe Anzeige*/

 if(argc!=2 || (argc==2 && !strcmp(argv[1], "-h"))) {
  printf("BlinkenLed\n"  "written by Nico Golde / Marko Adam\n"
    "License: GPL\n"  "usage: blinkled (<file>/-h)\n\n"
    "Die Datei kann die Zahle 0-7 mit folgender Bedeutung enthalten:\n");
  for (i=0; i<8; i++)
    printf("%d --> %c %c %c\n", i, i&2?'*':'o', i&4?'*':'o', i&1?'*':'o');
  return 0;
 }

/* ffnen des Keyboard Devices(rw)*/

 if((KB=open("/dev/console",O_RDWR))<0){ 
  perror("/dev/console");
  return -1;
 }

/* ffen der Datei mit den Daten(r)*/

 if((file=fopen(argv[1],"r"))==NULL){
  printf("Datei '%s' nicht gefunden...\n", argv[1]);
  return -2;
 }

/* einzelnes Auslesen der Datei*/

 while((o=i=fgetc(file))!=EOF && i>='0' && i<='7') {

/*Unterscheidung der Daten mit anschlieendem Ansteuern der LED*/
  i<<=1; i|=(i&8)>>3; i&=7;
  printf("%d --> %c %c %c\n", o&7, i&2?'*':'o', i&4?'*':'o', i&1?'*':'o');
  ioctl(KB,KDSETLED, i);
  usleep(300000);
 }

/* Ausmachen aller LED's --> Urzustand wiederherstellen*/
 ioctl(KB,KDSETLED,8);

 fclose(file);	/*Dieses Aufrumen macht das System zwar auch,*/
 close(KB);	/*aber ich gewhn mir das gar nicht erst an ...*/
 return 0;
}
